/*SpUpd!_2019.09.24_0000752*/
/*needVer=2019.09.03_0000751*/

CREATE TABLE MTL_KSLP (
    MTL_ID INTEGER,
    KOEF_ID SMALLINT,
    KOEF_VALUE NUMERIC(7,5));
@
CREATE INDEX MTL_KSLP_IDX1
ON MTL_KSLP (MTL_ID);
@
EXECUTE BLOCK AS
  DECLARE VARIABLE P_SQL VARCHAR(512);
BEGIN
  IF(NOT EXISTS(
    SELECT RF.RDB$FIELD_NAME
    FROM   RDB$RELATION_FIELDS RF
    WHERE  (TRIM(RF.RDB$RELATION_NAME) = 'REPORTS')
      AND  (TRIM(RF.RDB$FIELD_NAME) = 'MONTH_N')
  ))THEN
  BEGIN
    P_SQL = 'ALTER TABLE REPORTS ADD MONTH_N SMALLINT';
    EXECUTE STATEMENT :P_SQL;
  END
END
@
execute block
as
declare variable P_SQL varchar(512);
begin
  if (not exists(select *
                 from RDB$INDICES RF
                 where (trim(RF.RDB$RELATION_NAME) = 'REPORTS') and
                       (trim(RF.RDB$INDEX_NAME) = 'REPORTS_IDX1'))) then
  begin
    P_SQL = 'CREATE INDEX REPORTS_IDX1 ON REPORTS (LPU, OPLAT, TIP_STAC, MONTH_N)';
    execute statement :P_SQL;
  end
end;
@
CREATE trigger reports_bi0 for reports
active before insert position 0
AS
begin
  new.month_n = extract(month from new.date_beg);
end;
@
execute block
as
declare variable P_SQL varchar(512);
begin
  if (exists(select *
                 from RDB$INDICES RF
                 where (trim(RF.RDB$RELATION_NAME) = 'SPR_KSG_GROUP') and
                       (trim(RF.RDB$INDEX_NAME) = 'SPR_KSG_GROUP_IDX1'))) then
  begin
    P_SQL = 'DROP INDEX SPR_KSG_GROUP_IDX1';
    execute statement :P_SQL;
  end
end;
@
CREATE INDEX SPR_KSG_GROUP_IDX1
ON SPR_KSG_GROUP (ksg_id, DBEG,DEND);
@
execute block
as
declare variable P_SQL varchar(512);
begin
  if (exists(select *
                 from RDB$INDICES RF
                 where (trim(RF.RDB$RELATION_NAME) = 'MTL_CALC_HISTORY') and
                       (trim(RF.RDB$INDEX_NAME) = 'MTL_CALC_HISTORY_IDX1'))) then
  begin
    P_SQL = 'DROP INDEX MTL_CALC_HISTORY_IDX1';
    execute statement :P_SQL;
  end
end;
@
COMMIT WORK;